<?php include('./private/db_connect.php');?> 

<?php
    $search = $_POST['search'];
    $store_id = $_POST['store_id'];

    // Prepare your SQL query to search by name or SKU
    $sql = "SELECT inventory.id, inventory.product_id, inventory.qty, inventory.cprice, inventory.purchase_date, inventory.expire_date, inventory.date_updated, product_list.name, product_list.sku
            FROM inventory
            JOIN product_list ON inventory.product_id = product_list.id
            WHERE inventory.store_id = ? AND inventory.type = 1 AND (product_list.name LIKE ? OR product_list.sku LIKE ?)
            ORDER BY inventory.date_updated DESC
            LIMIT 100";

    $stmt = $conn->prepare($sql);
    $search = "%$search%";  // To match partial strings
    $stmt->bind_param("iss", $store_id, $search, $search);
    $stmt->execute();
    $result = $stmt->get_result();

    // Output as HTML to be injected into the table body
    if ($result->num_rows > 0) {
        $counter = 1;
        while ($row = $result->fetch_assoc()) {
            echo "<tr>";
            echo "<td class='text-center'>" . $counter . "</td>";
            echo "<td class='text-left'>" . htmlspecialchars($row['sku']) . "</td>";
            echo "<td class='text-left'>" . htmlspecialchars($row['name']) . "</td>";
            echo "<td class='text-left'>" . htmlspecialchars($row['purchase_date']) . "</td>";

            // Hidden columns for qty, cost_price, and expire_date
            echo "<td style='display:none;'>" . htmlspecialchars($row['qty']) . "</td>";
            echo "<td style='display:none;'>" . htmlspecialchars($row['cprice']) . "</td>";
            echo "<td style='display:none;'>" . htmlspecialchars($row['expire_date']) . "</td>";

            echo "<td class='text-center'>
                    <button class='btn btn-sm btn-primary view_product' type='button' data-id='" . $row['id'] . "'>View</button>
                </td>";
            echo "</tr>";
            $counter++;
        }
    } else {
        echo "<tr><td colspan='5' class='text-center'>No results found.</td></tr>";
    }

    $stmt->close();
?>