<?php
session_start();
include './private/db_connect.php';

header('Content-Type: application/json');

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$input = json_decode(file_get_contents('php://input'), true);

if (isset($input['store_id'], $input['ref_no'], $input['amount_paid'], $input['action_by'])) {
    $store_id = $input['store_id'];
    $ref_no = $input['ref_no'];
    $amount_paid = $input['amount_paid'];
    $action_by = $input['action_by'];

    $sql = "INSERT INTO debt_payment (store_id, ref_no, amount_paid, action_by) VALUES (?, ?, ?, ?)";
    $stmt = $conn->prepare($sql);

    if ($stmt === false) {
        echo json_encode(['success' => false, 'error' => 'Failed to prepare statement: ' . $conn->error]);
        exit;
    }

    $stmt->bind_param("isdi", $store_id, $ref_no, $amount_paid, $action_by);

    if ($stmt->execute()) {
        echo json_encode(['success' => true]);
    } else {
        echo json_encode(['success' => false, 'error' => 'Failed to execute statement: ' . $stmt->error]);
    }

    $stmt->close();
} else {
    echo json_encode(['success' => false, 'error' => 'Invalid input']);
}

$conn->close();
?>